const WXCrypt = require('../WXBizMsgCrypt');
const wxSDK = require('../wxSDK');

module.exports = function (config,loger,dbcon) {
    return async function (ctx) {
        const start = new Date();
        try {
            const wxcrypt = new WXCrypt(config.appID, config.token, config.AppKey);

            let str_post = ctx.request.body;
            let timestamp = ctx.query.timestamp;
            let nonce = ctx.query.nonce;
            let msg_signature = ctx.query.msg_signature;

            const decryptedMsg = wxcrypt.decryptMsg(msg_signature, timestamp, nonce, str_post);
            loger.info('推送消息', '>>>>', decryptedMsg);

            // const decryptedMsg = {
            //     ToUserName: 'gh_3c884a361561',
            //     FromUserName: 'ozy4qt5QUADNXORxCVipKMV9dss0',
            //     CreateTime: '1519464253',
            //     MsgType: 'text',
            //     Content: 'TESTCOMPONENT_MSG_TYPE_TEXT',
            //     MsgId: '6526049274483138870'
            // }

            switch (decryptedMsg.MsgType) {
                case 'text':
                    if (decryptedMsg.Content == 'TESTCOMPONENT_MSG_TYPE_TEXT') { //文本消息
                        ctx.body = wxcrypt.encryptMsg({
                            ToUserName: decryptedMsg.FromUserName,
                            FromUserName: decryptedMsg.ToUserName,
                            CreateTime: Math.round(new Date().getTime() / 1000),
                            MsgType: 'text',
                            Content: 'TESTCOMPONENT_MSG_TYPE_TEXT_callback'
                        });
                    }
                    else if (decryptedMsg.Content.startsWith('QUERY_AUTH_CODE:')) {
                        // { ToUserName: 'gh_3c884a361561',
                        // FromUserName: 'ozy4qt5QUADNXORxCVipKMV9dss0',
                        // CreateTime: '1519464244',
                        // MsgType: 'text',
                        // Content: 'QUERY_AUTH_CODE:queryauthcode@@@bS93PSRHe2dfxEus8dxyKWh24SR1TdYPTkapWAzeCpxNWCqMbBVKR7ECQGfcot9f6Vni0WA8Pp7TvDoVy7Schw',
                        // MsgId: '6526049235828433205' }

                        let wxsdk = new wxSDK(config, dbcon);
                        let resultjson = await wxsdk.获取公众号token(decryptedMsg.Content.replace('QUERY_AUTH_CODE:', ''));
                        wxsdk.公众号_发送消息(resultjson.authorization_info.authorizer_appid, resultjson.authorization_info.authorizer_refresh_token, {
                            touser: decryptedMsg.FromUserName,
                            msgtype: 'text',
                            text: {
                                content: decryptedMsg.Content.replace('QUERY_AUTH_CODE:', '') + '_from_api'
                            }
                        });
                    }
                    break;
                case 'image':

                    break;
                case 'voice':

                    break;
                case 'video':

                    break;
                case 'shortvideo':

                    break;
                case 'location':

                    break;
                case 'link':

                    break;
                case 'event':
                    if (decryptedMsg.Event == 'LOCATION') {
                        ctx.body = wxcrypt.encryptMsg({
                            ToUserName: decryptedMsg.FromUserName,
                            FromUserName: decryptedMsg.ToUserName,
                            CreateTime: Math.round(new Date().getTime() / 1000),
                            MsgType: 'text',
                            Content: decryptedMsg.Event + 'from_callback'
                        });
                    }
                    break;
                default:
                    throw new Error('微信推送消息时,未处理的类型' + decryptedMsg.InfoType);
                //break;
            }
            loger.info('推送消息', '<<<<', ctx.body, new Date() - start);
        } catch (error) {
            loger.error('推送消息', 'XXXX', error);
        }
        // finally {
        // }
    };
};